"""
MIT License

Copyright (c) 2023 Wilhelm Ågren

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

File created: 2023-05-13
Last updated: 2023-05-21
"""

import unittest
import logging
import random

import numpy as np
import pandas as pd

from synd.datautil import TabularTransformer

log = logging.getLogger(__name__)

class TabularTransformerTest(unittest.TestCase):
    """ Unit tests for the TabularTransformer class. """

    def test_fit_transformer(self):
        t = TabularTransformer()
        self.assertFalse(t.is_fitted())

        df = pd.DataFrame({
            'salary': np.random.randint(500, 10000, size=(1000, )),
            'gender': random.choices(['male', 'female', 'unknown'], k=1000),
        })

        t.fit(df, discrete_columns=['gender'])
        self.assertTrue(t.is_fitted())

